<template>
  <div class="app-container">

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['live:liveVideo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['live:liveVideo:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="liveVideoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="videoId" />
      <el-table-column label="视频名称" align="center" prop="remark" />
      <el-table-column label="视频地址" align="center" prop="videoUrl">
        <template slot-scope="scope">
          <video
            :src="scope.row.videoUrl"
            controls
            controlsList="nodownload"
            class="video-player"
            @contextmenu.prevent
          ></video>
        </template>
      </el-table-column>
      <el-table-column label="时长" align="center" prop="duration" :formatter="formatDuration"/>
      <el-table-column label="转码状态" align="center" prop="finishStatus">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.finishStatus == 1">转码成功</el-tag>
          <el-tag v-else-if="scope.row.finishStatus == 0">转码中</el-tag>
          <el-tag v-else>---</el-tag>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改直播视频对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <live-video-upload
          :type = "1"
          :isPrivate = "isPrivate"
          :fileKey.sync = "form.fileKey"
          :fileSize.sync = "form.fileSize"
          :videoUrl.sync="form.videoUrl"
          :fileName.sync="form.fileName"
          :line_1.sync="form.lineOne"
          :thumbnail.sync="form.thumbnail"
          :uploadType.sync="form.uploadType"
          :isTranscode.sync="form.isTranscode"
          :transcodeFileKey.sync="form.transcodeFileKey"
          @video-duration="handleVideoDuration"
          @change="handleVideoChange"
          ref="videoUpload"
          append-to-body
        />

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listLiveVideo, getLiveVideo, delLiveVideo, addLiveVideo, updateLiveVideo, exportLiveVideo } from "@/api/live/liveVideo";
import LiveVideoUpload from "@/components/LiveVideoUpload/index.vue";

export default {
  name: "LiveVideo",
  components: { LiveVideoUpload },
  data() {
    return {
      //字典
      videoTypeOptions: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 直播视频表格数据
      liveVideoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        liveId: -1,
        videoUrl: null,
        videoType: -1,
        sort: null,
      },
      // 表单参数
      form: {
        uploadType: 1,
        isTranscode:0,
        transcodeFileKey:null
      },
      // 表单校验
      rules: {
      },
      isPrivate:null,
    };
  },
  created() {
    this.getList();
  },
  methods: {
    handleVideoDuration(duration) {
      this.form.duration = duration;
    },
    handleVideoChange(videoUrl,lineOne){
      this.videoUrl = videoUrl;
      this.form.videoUrl = videoUrl;
      console.log(this.videoUrl)
    },
    // 操作日志类型字典翻译
    formatDuration(row, column) {
      if(row.duration == null) return "00:00"
      const h = Math.floor(row.duration / 3600);
      const m = Math.floor((row.duration % 3600) / 60);
      const s = Math.floor(row.duration % 60);

      // 补零处理
      const format = (num) => num.toString().padStart(2, '0');

      return h > 0
        ? `${h}:${format(m)}:${format(s)}`
        : `${format(m)}:${format(s)}`;
    },
    /** 查询直播视频列表 */
    getList() {
      this.loading = true;
      listLiveVideo(this.queryParams).then(response => {
        this.liveVideoList = response.rows;
        this.liveVideoList.forEach(item => {
          item.videoUrl = item.videoUrl.replace(".m3u8", ".mp4");
        });
        this.total = response.total;
        this.loading = false;
      });
    },
    videoTypeFormatter(row, column) {
      return this.selectDictLabel(this.videoTypeOptions, row.status);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        videoId: null,
        liveId: null,
        videoUrl: null,
        videoType: null,
        sort: null,
        createTime: null,
        createBy: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.videoId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加直播视频";
      this.videoUrl = '';
      setTimeout(() => {
        this.$refs.videoUpload.reset();
      }, 500);
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const videoId = row.videoId || this.ids
      getLiveVideo(videoId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改直播视频";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.videoType = -1;
          this.form.liveId = -1;
          this.form.remark = this.form.fileName;
          if(this.form.videoUrl == null || this.form.videoUrl == "") {
            this.msgError("请上传视频");
            return;
          }
          this.form.videoUrl = this.form.videoUrl.replace('.mp4', '.m3u8');
          addLiveVideo(this.form).then(response => {
            this.msgSuccess("新增成功");
            this.open = false;
            this.getList();
            this.reset();
          });

        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const videoIds = row.videoId || this.ids;
      this.$confirm('是否确认删除直播视频编号为"' + videoIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delLiveVideo(videoIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有直播视频数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportLiveVideo(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>

<style scoped>
.video-player {
  width: 100%;
  height: 100%;
  object-fit: cover;
}
</style>
